<template>
    <Header
        :isStudent="isStudent"
        :routeNameHomePageRole="routeNameHomePageRole"
        :menuFiltered="menuFiltered"
    />

    <SideBar
        :isStudent="isStudent"
        :routeNameHomePageRole="routeNameHomePageRole"
        :menuFiltered="menuFiltered"
    />

    <div
        class="container app-content mx-auto px-4 pt-21"
        :class="[isStudent ? 'md:px-52' : 'md:pl-80 md:pr-8']"
    >
        <slot />
    </div>

    <Footer :isStudent="isStudent" />
</template>

<script>
import { computed, inject, ref } from "vue";
import { useRouter } from "vue-router";
import { MENU } from "@/configs/menu";
import { ROLE_ADMIN, ROLE_TEACHER, ROLE_STUDENT } from "@/constants";

import Header from "./header.vue";
import Footer from "./footer.vue";
import SideBar from "./sidebar.vue";

export default {
    components: {
        Header,
        Footer,
        SideBar
    },
    setup() {
        const store = inject("store");
        const router = useRouter();
        const isStudent = ref(false);
        const routeNameHomePageRole = ref("student");

        const menuFiltered = computed(() => {
            return MENU.filter(item =>
                item.role.includes(
                    store.state.user ? store.state.user.role : false
                )
            );
        });

        if (store.state.user) {
            if (store.state.user.role === ROLE_ADMIN) {
                routeNameHomePageRole.value = "admin";
            } else if (store.state.user.role === ROLE_TEACHER) {
                routeNameHomePageRole.value = "teacher";
            } else if (store.state.user.role === ROLE_STUDENT) {
                routeNameHomePageRole.value = "student";
                isStudent.value = true;
            }
        } else {
            router.push({ name: "login", params: {} });
        }

        return {
            isStudent,
            routeNameHomePageRole,
            menuFiltered
        };
    }
};
</script>
